#if !defined(__COMWIN_H__)
#define      __COMWIN_H__

#include <windows.h>

LONG  FAR PASCAL Puts(LPSTR);
LPSTR FAR PASCAL Gets(LPSTR);
LONG  FAR PASCAL Fputs(LPSTR, LPSTR);
LPSTR FAR PASCAL Fgets(LPSTR, LONG, LPSTR);
LONG  FAR PASCAL System(LPSTR);
BOOL  FAR PASCAL CallCommand(FARPROC FAR *, LPSTR, LPLONG);
LONG  FAR PASCAL Getch(void);
LONG  FAR PASCAL Inkey(void);
LONG  FAR PASCAL Fwrite(LPVOID, LONG, LONG, LPSTR);
LONG  FAR PASCAL Fread(LPVOID, LONG, LONG, LPSTR);

LONG  FAR PASCAL GetComWinLong(LONG, LONG);
int   FAR PASCAL MakeArgument(HINSTANCE, LPSTR, LPSTR, LPINT, LPSTR, int);
LONG  FAR PASCAL cwPutenv(LPSTR);
LPSTR FAR PASCAL cwGetenv(LPSTR);
LONG  FAR CDECL  cwFprintf(LPSTR, LPSTR, ...);

typedef LONG  (FAR PASCAL *PUTS)(LPSTR);
typedef LPSTR (FAR PASCAL *GETS)(LPSTR);
typedef LONG  (FAR PASCAL *FPUTS)(LPSTR, LPSTR);
typedef LPSTR (FAR PASCAL *FGETS)(LPSTR, LONG, LPSTR);
typedef LONG  (FAR PASCAL *SYSTEM)(LPSTR);
typedef BOOL  (FAR PASCAL *CALLCOMMAND)(FARPROC FAR *, LPSTR, LPLONG);
typedef LONG  (FAR PASCAL *GETCH)(void);
typedef LONG  (FAR PASCAL *INKEY)(void);
typedef LONG  (FAR PASCAL *FWRITE)(LPVOID, LONG, LONG, LPSTR);
typedef LONG  (FAR PASCAL *FREAD)(LPVOID, LONG, LONG, LPSTR);

#define CW_GETVER  0
#define CW_GETENV  1
#define CW_GETHWND 2
#define CW_GETMSG  3

/* Message */
#define CW_M_EXEC         0xFFFFFFFF
#define CW_M_HELP         0x00000000
#define CW_M_CONSOLE_INFO 0x00010001
#define CW_M_USER_FIRST   0x10000000
#define CW_M_USER_LAST    0x7FFFFFFF
/*
    0x00000001 - 0x0000FFFF reserved
    0x00010002 - 0x0FFFFFFF system reserved
    0x10000000 - 0x7FFFFFFF user area
    0x80000000 - 0xFFFFFFFE reserved
 */

/* Mode */
#define CW_MODE_CLEAR 0
#define CW_MODE_INIT  1
#define CW_MODE_SET   2
#define CW_MODE_GET   3

/* Message Structure */
typedef struct CW_S_CONSOLE_INFO
               CW_S_CONSOLE_INFO,
       FAR *LP_CW_S_CONSOLE_INFO;

struct CW_S_CONSOLE_INFO {
    LONG  lMessage;    // Message Number (= CW_M_CONSOLE_INFO)
    LONG  lSize;       // Structure size (= sizeof(CW_S_CONSOLE_INFO))
    LONG  lMode;       // Calling mode (= CW_MODE_XXXX)
    LONG  lFuncMax;    // Max Function Count ( >= 6)
    LONG  lBufMax;     // Max Buffer Size ( for Gets API etc)
    DWORD hwnd;        // Window Handle of Console
    LONG  lColumns;    // Columns of Console
    LONG  lLines;      // Lines of Console
    LONG  lWidth;      // Width of Console
    LONG  lHeight;     // Height of Console
};

#endif
